sub s4gjinv (ncol,b(2),z(1),determ,ipmi,ising) static
'---- Subroutine for Gauss-Jordan matrix inversion
'         Solves Bx=Z, output is Binv in B, and x in Z
'  IPMI  print matrix inverse if true
'  ISING becomes true (-1) for singular matrix

  redim indx(ncol,3)
  ising=0

'
'---  make B the full matrix
  for k=1 to ncol : for l=1 to k : b=b(k,l) : b(l,k)=b : next : next

  FOR I=1 TO NCOL: INDX(I,3)=0: NEXT
'   Determ=1

    FOR I=1 TO NCOL 'find largest element (pivot)
      B1=0
      FOR J=1 TO NCOL
        IF INDX(J,3)=1 THEN goto gj2
        FOR IT=1 TO NCOL
          IF INDX(IT,3)>1 THEN goto gj6
          IF INDX(IT,3)=1 THEN goto gj1
          IF B1>=ABS(B(J,IT)) THEN goto gj1
          I3=J: I4=IT
          B1=ABS(B(J,IT))
gj1:    NEXT
gj2:  NEXT

      i43=INDX(I4,3) : INDX(I4,3)=i43+1
      INDX(I,1)=I3
      INDX(I,2)=I4

  '--- interchange rows to put pivot on diagonal
      IF I3=I4 THEN goto gj3
  '  Determ=-Determ
      FOR L=1 TO NCOL
         t1=B(I3,L) : t2=B(I4,L)
         B(I3,L)=t2 : B(I4,L)=t1
      NEXT
      t1=Z(I3) : t2=Z(I4)
      Z(I3)=t2 : Z(I4)=t1

  '--- divide pivot row by pivot element
gj3:  PIVOT=B(I4,I4)
      ' Determ=Determ*PIVOT
      B(I4,I4)=1
      FOR L=1 TO NCOL: BI4L=B(I4,L) : B(I4,L)=BI4L/PIVOT: NEXT
      ZI4=Z(I4) : Z(I4)=ZI4/PIVOT
  '---reduce nonpivot rows
      FOR L1=1 TO NCOL
        IF L1=I4 THEN goto gj4
        T=B(L1,I4): B(L1,I4)=0
        FOR L=1 TO NCOL
           BI4L=B(I4,L) : BL1L=B(L1,L)
           B(L1,L)=BL1L-BI4L*T
        NEXT
        ZI4=Z(I4) : ZL1=Z(L1)
        Z(L1)=ZL1-ZI4*T
gj4: NEXT 
   NEXT

  '---- interchange columns
   FOR I=1 TO NCOL
     L=NCOL-I+1
     IF INDX(L,1)=INDX(L,2) THEN goto gj5
     I3=INDX(L,1)
     I4=INDX(L,2)
     FOR IT=1 TO NCOL
      t1=B(IT,I3) : t2=B(IT,I4)
      B(IT,I3)=t2 : B(IT,I4)=t1
     NEXT
gj5: NEXT I
   FOR IT=1 TO NCOL
     IF INDX(IT,3)<>1 THEN goto gj6
   NEXT
   if not ipmi then exit sub
   PRINT #6, "Matrix inverse
   FOR I=1 TO NCOL
     FOR J=1 TO NCOL
       PRINT #6, USING fndform$(10,6); B(I,J);
     NEXT
   PRINT #6, ""
   NEXT
'  PRINT #6,"Determinant = ";Determ
exit sub
gj6:  ising=-1
   end sub
