'--- Pulls station list out of CD-ROM file, STACOORD.DAT and builds lists
'    in format for SYN3 and SYN4 programs. One file STATION.DAT of all valid
'    stations, a file WWSSNST.DAT of only WWSSN stations, and a file NGSTA.DAT
'    of stations without station latitudes.
'--- Written by Fauzi at RPI 12/17/90
'--- Modified by Peter Zwick at RPI 12/18/90

OPEN "i", #1, "stacoord.dat", 20000
OPEN "o", #2, "station.dat", 20000
OPEN "o", #3, "wwssnst.dat", 2048
OPEN "o", #4, "ngsta.dat", 1024

  WHILE NOT EOF(1)
    LINE INPUT #1, a$
    PRINT a$
    sta$ = LCASE$(LEFT$(a$, 4))
    lat$ = MID$(a$, 45, 2)
    latmin$ = MID$(a$, 47, 2)
    latsec$ = MID$(a$, 49, 2)
    IF latmin$ > "59" OR latsec$ > "59" THEN PRINT "error in STACOORD.DAT": END
    IF LTRIM$(lat$) <> "" THEN
      ns$ = MID$(a$, 52, 1)
      i = 1
      IF UCASE$(ns$) = "S" THEN i = -1
      j = 1
      lon$ = MID$(a$, 53, 3)
      longmin$ = MID$(a$, 56, 2)
      longsec$ = MID$(a$, 58, 2)
      IF longmin$ > "59" OR longsec$ > "59" THEN PRINT "error in STACOORD.DAT": END
      we$ = MID$(a$, 61, 1)
      IF UCASE$(we$) = "W" THEN j = -1
      elev$ = MID$(a$, 62, 4)
      statype$ = UCASE$(MID$(a$, 66, 1))
      olat = (VAL(lat$) + VAL(latmin$) / 60! + VAL(latsec$) / 3600!) * i
      olon = (VAL(lon$) + VAL(longmin$) / 60! + VAL(longsec$) / 3600!) * j

      PRINT #2, USING "\  \"; sta$;
      PRINT #2, USING "+##.###"; olat;
      PRINT #2, USING "+###.###"; olon;
      PRINT #2, USING "\  \"; elev$
      IF statype$ = "W" THEN
         PRINT #3, USING "\  \"; sta$;
         PRINT #3, USING "+##.###"; olat;
         PRINT #3, USING "+###.###"; olon;
         PRINT #3, USING "\  \"; elev$
      END IF
    ELSE
      PRINT #4, a$
    END IF
  WEND
  CLOSE
STOP


