' STEREONT.BAS  constructs stereonet drawing
' By Peter Zwick  April, 1991

DEFINT I-N: OPTION BASE 1
CONST NSTAMAX=1 'dummy variable

rem $INCLUDE: 's4comscr'
rem $INCLUDE: 's4fndecl'
rem $INCLUDE: 's4functn'
rem $INCLUDE: 's4rdset'

rem $DYNAMIC
dim projx(91,91),projy(91,91)


'-- call welcome
prgnm$="STEREONT"

   call setscreen(0)
   print prgnm$+" - Reading config file...";
   call READSET
   call scbox(1,11,0,"(C) Copyright RPI 1991","")
   call sccenter("Welcome to "+prgnm$,3)
   call sccenter("- constructs stereonet plot file -",5)
   call sccenter("by",7)
   call sccenter("P. Zwick & R. McCaffrey",8)

'-- initialize variables
igraph=2  'Postscript output default
fext$="PS"
plang$="PlotCall  PostScriptLaserJet3 Plot8x11  Plot11x17 "
outf$="TMP"
dia=7.5
kunit=1 'inch units default'
units$="incm"
ldat=2

'-- initialize plot parameters
  xmax=9.84:ymax=7.87:xscale=1:yscale=.9907
  kpenhp=ktrue:lcode=0:khpcol=0:lcode=0
  scrorig=0
  letset=20
  szlet=2.  'mm 0.08 in.
  anglet=0
  irotate=ktrue
  xoff=0: yoff=0
  gscale=1.0 'calls to gssubs will be in mm
  if igraph<>2 then yoff=0

'---- convert plot coords (250x200mm) to undistorted screen coordinates
  if (kscry-200*scratio*kscrx/250)<0 then  'if screen too wide
     fisx=kscry/(scratio*200)  '           'pixels/(mm x dimension)
     fisy=kscry/200                        'pixels/(mm y dimension)
  else
     fisx=kscrx/250
     fisy=kscrx*scratio/250
  end if

'-- set up graphics
  def fnisx(x) = cint(x*fisx)
  def fnisy(y) = cint(kscry-(y-scrorig)*fisy)

'-- open files
call scpause(18,3)

100 call setscreen(0)
klst$="oldxqb"
lb=10
call scbox(1,lb,ktrue,"MENU","Q or Esc to quit")
call scprint(2,2,"KEY  OPTION"):call scprint(2,50,"VALUE")
call scprompt(4,3,"O - Output file")
call scprompt(5,3,"L - plot Language")
call scprompt(6,3,"D - Diameter")
call scprompt(7,3,"X/"):call scprompt(7,5,"Q - Shell/Quit")
call scprompt(8,3,"B - Begin")

call setvarcol
call scprint(4,50,outf$)
call scprint(5,50,mid$(plang$,1+(igraph-1)*10,10))
if kpenhp then kp$="2" else kp$="1"
if igraph>3 then call scprint(5,65,kp$+" pen")
call scprint(6,50,fnstrnum$(dia)+" "+mid$(units$,kunit*2-1,2))

a$=right$(klst$,1)
101   ik=input1(lb+1,1,"Enter KEY for option ",a$,kfalse,ktrue,ktrue,klst$)

if a$="q" or ik=27 then
  call endcheck:goto 101

elseif a$="d" then
  d$=fnstrnum$(dia)
  c$=chr$(34)
  if inputn(lb+1,2,"Enter diameter (8"+c$+" or 20 cm is max for an 8-1/2x11"_
      +c$+" sheet)",d$,ktrue,ktrue,kfalse,"f",8)<>27 then
    dia=val(d$)
    d$=mid$("ic",kunit,1)
    if input1(lb+2,2,"inches or cm (I/C)? ",d$,kfalse,ktrue,ktrue,"ic")<>27 then
      if d$="i" then kunit=1 else kunit=2
    endif
  endif

elseif a$="o" then
  f$=fnaddext$(outf$,fext$)
  if inputn(lb+1,1,"Enter output file name (."+fext$+")",f$,ktrue,ktrue,ktrue,"a",40)<>27 then
    f$=ucase$(fnaddext$(f$,fext$))
    if not keepold(f$) then outf$=f$
  end if

elseif a$="l" then
  call scprompt(lb+1,2,"1-PLOTCALL (Golden Software)")
  call scprompt(lb+2,2,"2-PostScript")
  call scprompt(lb+3,2,"3-HP LaserJet3")
  call scprompt(lb+4,2,"4-HP Plotter,8.5"+chr$(34)+"x11"+chr$(34))
  call scprompt(lb+5,2,"5-HP Plotter,11"+chr$(34)+"x17"+chr$(34))
  d$=fnstrnum$(igraph)
  if input1(lb+7,2,"Output file plot language ",d$,kfalse,ktrue,kfalse,"12345")<>27 then
    igraph=val(d$)
    if igraph=1 then fext$="PLT"
    if igraph=2 then fext$="PS"
    if igraph>2 then fext$="HP"
    if igraph>3 then
      if input1(lb+8,2,"1 or 2 pens? ",kp$,kfalse,ktrue,kfalse,"12")<>27 then_
        kpenhp=(kp$="2")
    endif
  end if

elseif a$="x" then
  call shellcom

elseif a$="b" then
  call setscreen(kega)
  call scprint(1,1,"(Press Esc to interrupt)")
  goto 102

end if

goto 100


102  if outf$<>"" then call gsopen(fnaddext$(outf$,fext$)) else call gsopen("tmp.ps")
if igraph=2 then
  scrorig=8
  xoffadd=4.5*25.4: yoffadd=4.25*25.4
else
  scrorig=-2
  xoffadd=4.5*25.4: yoffadd=3.85*25.4
endif
call gsinit(outf$)
if igraph>3 then print#7,"VS 20" 'Slow pen speed and acceleration down
call gsorig(xoff,yoff)
if kunit=1 then Re=dia*25.4/2 else Re=dia*5


j=0
call scline2(fnisx(0),fnisy(scrorig),fnisx(250),fnisy(200+scrorig), 1, ktrue)
call sccircle(fnisx(xoffadd),fnisy(yoffadd),fnisx(Re),1)
for isc = 90 to -90 step -2 'step through for small circles
  j=j+1
  if fninesc then goto 100
  aiscr=fnrad(isc)
  offsety=Re*sin(aiscr)
  y2=offsety*offsety
  del=Re*cos(aiscr)
  if isc MOD 10 = 0 then
    ilntype=1
    if igraph=2 then print#7,"SN 1.0 SL"
  else
    ilntype=2
    if igraph=2 then print#7,"SN 0.3 SL"
  endif
  if isc MOD 4=0 then ktrm=1 else ktrm=-1
  if isc = 90 then
    call gscircle(xoffadd,yoffadd,Re,.5,ilntype)
  elseif isc > -90 then
    call gsmove(ktrm*del+xoffadd,offsety+yoffadd,ilntype)
  endif
'  i=0
  for igc = 90 to -90 step -2 'step through for great circles
'    i=i+1
    if fninesc then goto 100
    i=(92-ktrm*igc)/2
    aigcr=fnrad(ktrm*igc)
'    aigcr=fnrad(igc)
    offsetx=del*sin(aigcr)
    a2=offsetx*offsetx+y2
    offsetz=Re-del*cos(aigcr)
    p2=a2+offsetz*offsetz
    if a2>0 then pratio=sqr(p2/(2*a2)) else pratio=0
    projx(j,i)=pratio*offsetx+xoffadd
    projy(j,i)=pratio*offsety+yoffadd
    if abs(isc)<90 then call gsdraw(projx(j,i),projy(j,i),ilntype)
  next
next

for i = 2 to 90 'step through for great circles
  if fninesc then goto 100
  if (i-1) MOD 5 = 0 then
    ilntype=1
    if igraph=2 then print#7,"SN 1.0 SL"
    if (i-1) MOD 15 = 0 then
      jstrt=1
      jend=91
    else
      jstrt=3
      jend=89
    endif
  else
    ilntype=2
    if igraph=2 then print#7,"SN 0.3 SL"
    jstrt=11
    jend=81
  endif
  if i MOD 2=0 then
    ktrm=1
  else
    ktrm=-1
    swap jstrt,jend
  endif
  call gsmove(projx(jstrt,i),projy(jstrt,i),ilntype)
  for j=jstrt+ktrm to jend step ktrm 'step through for small circles
    if fninesc then goto 100
    if projx(j,i)<20 then print j,i,projx(j,i)
    call gsdraw(projx(j,i),projy(j,i),ilntype)
  next
next
ilntype=1
if igraph=2 then print#7,"SN 1.0 SL"
call gscircle(xoffadd,yoffadd,Re,.5,ilntype)
if igraph>3 then print#7,"VS"  'reset pen velocity

'-- close files
if outf$<>"" then call gsclose(outf$) else call gsclose("tmp.ps")
goto 100
end

rem $INCLUDE: 's4grsubs'

