' main SYN4LIST
' make list of WWSSN and GDSN stations and their distances from event
'  this is to aid in deciding which seismograms to use
' input format for events is in EVENT HEADER format given in manual

DEFINT I-N: OPTION BASE 1
CONST NSTAMAX=1  'dummy variable not used

rem $INCLUDE: 'S4COMSCR'
rem $INCLUDE: 's4fndecl'
rem $INCLUDE: 's4functn'

'--- welcome
prgnm$="SYN4LIST"
call welcome

'-- maximum number of stations in file is 250
maxwwsta=250
dim wws$(maxwwsta), adlat(maxwwsta), adlon(maxwwsta),isnum(maxwwsta)
dim network(maxwwsta)
'dim timeon$(maxwwsta), timeoff$(maxwwsta)

dim iah(2),iam(2),asec(2), isflag(10)

'----------- travel time tables ---------
'-- set up for 2 phases, 120 deltas, 15 depths
dim ttimtab(120,15,2), dep(15,2), vsurf(2)
dim del0(2), ddelt(2), ndel(2), ndep(2)

'-- read in stations
   gosub READSTA

'-- read travel time table
  ttfile$=syndir$+"s4j-b.dat"
  call readtime (ttfile$)

  call scpause(18,3)

   islist$="01" : isflag(1)=ktrue: isflag(2)=ktrue
   neq=0
   fin$="KEYBOARD" : va2=6.0 : dmin=30: dmax=90
   neqs=1: fout$="STALIST.OUT"

MENU:
a$=""
call setscreen(0)
call scbox(1,16,ktrue,"MAIN MENU","Press Esc to quit")
call scprint(3,2,"KEY  OPTION                                    VALUE")
call scprompt(4,3,"P - P wave velocity at source (km/sec)")
call scprompt(6,3,"I - input file")
call scprompt(7,3,"O - output file")
call scprompt(9,3,"M - minimum and maximum delta for list")
call scprompt(11,3,"N - networks to include in list")
call scprint(12,7,"(0)WWSSN (1)DWWSSN, (2)SRO/ASRO, (3)others (e.g. 01 for 0 and 1)")
call scprompt(14,3,"X - DOS shell")
call scprompt(15,3,"B - begin")

'-- now write variables
call setvarcol
call sclocate(4,50):print va2;
call scprint(6,50,fin$)
call scprint(7,50,fout$)
call sclocate(9,50):print dmin;dmax;
call scprint(11,50,islist$)

ik= input1(17,1,"Enter KEY for option ",a$,kfalse,ktrue,ktrue,"piomnxbq")
'locate 18,1
 if ik=27 or fniquit(a$) then call endcheck: goto menu

if a$="p" then
    input " Source P-velocity (km/sec) ";v
    if v>0 then va2=v
elseif a$="b" then
     goto BEGIN
elseif a$="x" then 
     call shellcom
elseif a$="i" then
    input " File for input (K for keyboard) "; f$
      if len(f$)>0 then 
        fin$=ucase$(f$)
       if fin$="K" then
         fin$="KEYBOARD"
       else
         k1=(isfile(fin$, 0, f$, -1)=0)
       end if
      end if

elseif a$="m" then
    input " Minimum and maximum delta for list"; dmin,dmax
elseif a$="n" then
      print " Enter networks to include in list
      print " (0)WWSSN (1)DWWSSN, (2)SRO/ASRO, (3-9)others (e.g. 01 for 0 and 1) "
      input islist$
     for i=0 to 9
      l$=fnstrnum$(i)
      if instr(islist$,l$) then isflag(i+1)=ktrue else isflag(i+1)=kfalse
     next
      if isflag(1) then isflag(2)=ktrue
elseif a$="o" then
   input "Enter output file"; f$
   if (instr(f$,"*")+instr(f$,"?"))=0 then
      if len(f$)>0 then if not keepold(f$) then fout$=ucase$(f$)
   else
      print "Wildcard characters (* or ?) not allowed in output file name. Press any key..";
      f$=input$(1)
   endif
endif
goto MENU

'========================================================================


BEGIN:
     ikey=(fin$="KEYBOARD")
'     if (not ikey) then if not ifopen("i",6,fin$,0,ktrue) then goto MENU

     if (not ikey) then 
        if isfile(fin$, 0, f$, 1)<>0 then
            print "Invalid input file "
            input "  Press any key ... "; d$ : goto MENU
        end if
        open "i",6,fin$
     end if

     open "o",2,fout$
     print : print " Press Q or Esc to interrupt "

NEXTEQ:

    if fninquit(0) or fninesc then close : goto MENU

    if ikey then
      kheader=kfalse
    else
      kheader=ktrue
      if eof(6) then 1100
      line input #6, a$
    end if

      gosub GETHYPO
      if iend then close : goto MENU
      if ierrin then print "Not a valid event " : print a$ : goto NEXTEQ

      ipg=1 : nout=0 : neq=neq+1
      print : print "Processing ";dat$
478  npp=53

560 gosub 2000

580 for ks=1 to nwsta

       if fninquit(0) or fninesc then close : goto MENU
       nw=network(ks)
        if not isflag(nw+1) then 1080
'       if dat$<timeon$(ks) then 1080
'       if dat$>timeoff$(ks) then 1080

600    stalat=adlat(ks) : stalon=adlon(ks)
      call s4delaz(stalat,stalon,eplat,eplon,del,az)
       if del <dmin or del >dmax then 1080
680   call s4delaz(eplat,eplon,stalat,stalon,del,baz)

'--- get theoretical arrival time, and derivatives dT/dh, dT/dz
     toa=15
760   for iph=1 to 2
       iah(iph)=0: iam(iph)=0 : asec(iph)=0
       call travtime (iph, del, dep, ttime, dtdh, dtdz)
       if ttime=0 then 805
       call ellipcor (iph, del, eplat, stalat, ecor) 
       ttime=ttime+ecor
770   ttime=ttime + origin
780   ah=int(ttime/3600) : iah(iph)=int(ah)
790   ttime=ttime-ah*3600 : am=int(ttime/60) :iam(iph)=int(am)
800   asec(iph)=ttime-am*60
      if iph=1 then toa=fndeg(fnasin(dtdh*va2))
805  next

950   nout=nout+1 : if nout =npp then gosub 2000
980   PRINT #2, USING fnaform$(4); ucase$(WWS$(KS)); 
1000  PRINT #2, USING fniform$(4);ISNUM(KS);
1010  PRINT #2, USING fnfform$(10,2);DEL; AZ; BAZ; TOA;
1020  print #2," ";
      for iph=1 to 2
      print #2, "  ";
1025  PRINT #2, USING fniform$(2)+":"; IAH(iph); IAM(iph);
1030  PRINT #2, USING fnfform$(4,1); ASEC(iph);
      next : print #2, ""

1080 NEXT

1090 goto NEXTEQ

1100 close : end

2000 '----- subroutine to print header
2010 if neq=1 and ipg=1 then 2020
2015  print #2, chr$(12)  'form feed
2020 print #2,"Event";tab(10);
2022 print #2,"  Latitude Longitude     Depth  Origin Time";
2023 print #2, tab(75);"Page"
2024 print #2, dat$;tab(10);
2028 print #2, using fnfform$(10,3);eplat;eplon;dep;
     print #2, "   ";
2030 print #2, using fniform$(2)+":";ohr;omin;
2040 print #2, using fnfform$(4,1); osec;
2042 print #2, tab(76);ipg
2045 print #2, " "
2050 PRINT #2,"Stat.  N     Delta   Azimuth    Backaz  Take-off     P-time     S-time"
2055 PRINT #2, STRING$(79,45)
2060 nout=0: ipg=ipg+1
2100 return

READSTA: '---- read tables and stations
      call scprint(18,3 ,"Reading station list ...")

10100 iff$=syndir$+"s4statio.dat"
10220 if not ifopen("i",1,iff$,0,ktrue) then end: i=0

10240 line input #1, a$
        if fnvalue$(1,1)="'" goto 10240
        if fnvalue$(1,3)="zzz" goto 10360
        if eof(1) then goto 10360
        i=i+1 
      wws$(i)=fnvalue$(1,4)  : adlat(i)=fnvalue(5,7)
      adlon(i)=fnvalue(12,9) : isnum(i)=fnvalue(21,4)
      network(i)=fnvalue(27,1)
'     timeon$(i)=fnvalue$(30,6) : timeoff$(i)=fnvalue$(37,6) 
      if i=maxwwsta then 10360
      goto 10240

10360 nwsta=i
      close 1

'---  re-order stations by number
    for i=1 to nwsta
     minn=isnum(i) : min=i
      for j=i+1 to nwsta
       if isnum(j)<minn then minn=isnum(j) : min=j
      next
      swap wws$(i),wws$(min)
      swap adlat(i),adlat(min)
      swap adlon(i),adlon(min)
      swap isnum(i),isnum(min)
      swap network(i),network(min)
'     swap timeon$(i),timeon$(min)
'     swap timeoff$(i),timeoff$(min)
    next

  return
'======================================================================
GETHYPO:
'-- read in hypocenter data
  iend=0 : ierrin=0

  if kheader then
    if len(a$)<20 then ierrin=ktrue : return
    i=fnvalue(1,2) 
      if not fninlim(i,0,99) then ierrin=ktrue : return
    i=fnvalue(3,2)
      if not fninlim(i,1,12) then ierrin=ktrue : return
    i=fnvalue(5,2)
      if not fninlim(i,1,31) then ierrin=ktrue : return
    i=fnvalue(7,2)
      if not fninlim(i,0,24) then ierrin=ktrue : return
    i=fnvalue(9,2)
      if not fninlim(i,0,60) then ierrin=ktrue : return
    dat$=fnvalue$(1,6)
    ohr=fnvalue(7,2)
    omin=fnvalue(9,2)
    osec=fnvalue(11,3)/10
    eplat=fnvalue(14,5)/100
    eplon=fnvalue(19,6)/100 
    dep=fnvalue(25,3)
    hend$=fnvalue$(28,len(a$)-27)
    xmag=fnvalue(28,2)/10 
 else
    cls
    input " Date of event (YYMMDD) (999999 for MENU) "; dat$
       if dat$>="999999" or mid$(dat$,3,1)="9" then iend=ktrue : return
    input " Hour "; ohr
    input " Minute "; omin
    input " Second "; osec
    input " Latitude (+North) "; eplat
    input " Longitude (+East) "; eplon
    input " Depth (km) "; dep
 end if

'-- origin time in seconds
    origin=ohr*3600 + omin*60 + osec
return
'======================================================================
rem $INCLUDE: 's4delaz'
rem $INCLUDE: 's4ttimes'
rem $INCLUDE: 's4rdset'
'======================================================================
